<?php

namespace App\Controllers\Specimen;

use CodeIgniter\API\ResponseTrait;
use App\Controllers\BaseController;
use App\Models\Specimen\SpecimenModel;

class SpecimenController extends BaseController {
    use ResponseTrait;

    protected $db;
    protected $model;
    protected $rules;

    public function __construct() {
        $this->db = \Config\Database::connect();
        $this->model = new SpecimenModel();
        $this->rules = [];
    }

    public function index() {
        try {
            $rows = $this->model->findAll();
            return $this->respond([ 'status' => 'success', 'message'=> "data fetched successfully", 'data'   => $rows ], 200);
        } catch (\Exception $e) {
            return $this->failServerError('Exception : '.$e->getMessage());
        }
    }

    public function show($id) {
        try {
            $row = $this->model->where('SID',$id)->first();
            if (empty($row)) {
                return $this->respond([ 'status' => 'success', 'message'=> "data not found", 'data' => null ], 200);
            }
            return $this->respond([ 'status' => 'success', 'message'=> "data fetched successfully", 'data'   => $row ], 200);
        } catch (\Exception $e) {
            return $this->failServerError('Exception : '.$e->getMessage());
        }
    }

    public function create() {
        $input = $this->request->getJSON(true);
        if (!$this->validateData($input, $this->rules)) { return $this->failValidationErrors($this->validator->getErrors()); }
        try {
            $id = $this->model->insert($input);
            return $this->respondCreated([ 'status'  => 'success', 'message' => "data $id created successfully" ]);
        } catch (\Exception $e) {
            return $this->failServerError('Something went wrong: ' . $e->getMessage());
        }
    }

    public function update() {
        $input = $this->request->getJSON(true);
        if (!$this->validateData($input, $this->rules)) { return $this->failValidationErrors($this->validator->getErrors()); }
        try {
            $id = $this->model->update($input['SID'], $input);
            return $this->respondCreated([ 'status'  => 'success', 'message' => "data $id updated successfully" ]);
        } catch (\Exception $e) {
            return $this->failServerError('Something went wrong: ' . $e->getMessage());
        }
    }

}
